Index: uspace/lib/display/include/disp_srv.h
===================================================================
--- uspace/lib/display/include/disp_srv.h	(revision 338d09353f53dcb5fd2a315562bcd0b2588792d0)
+++ uspace/lib/display/include/disp_srv.h	(revision a2e104e0deacc5a9fdacf4d8e3824726c77c47a5)
@@ -54,4 +54,5 @@
 	errno_t (*window_create)(void *, display_wnd_params_t *, sysarg_t *);
 	errno_t (*window_destroy)(void *, sysarg_t);
+	errno_t (*window_move_req)(void *, sysarg_t, gfx_coord2_t *);
 	errno_t (*window_resize)(void *, sysarg_t, gfx_coord2_t *, gfx_rect_t *);
 	errno_t (*get_event)(void *, sysarg_t *, display_wnd_ev_t *);
Index: uspace/lib/display/include/display.h
===================================================================
--- uspace/lib/display/include/display.h	(revision 338d09353f53dcb5fd2a315562bcd0b2588792d0)
+++ uspace/lib/display/include/display.h	(revision a2e104e0deacc5a9fdacf4d8e3824726c77c47a5)
@@ -49,4 +49,5 @@
 extern errno_t display_window_destroy(display_window_t *);
 extern errno_t display_window_get_gc(display_window_t *, gfx_context_t **);
+extern errno_t display_window_move_req(display_window_t *, gfx_coord2_t *);
 extern errno_t display_window_resize(display_window_t *,
     gfx_coord2_t *, gfx_rect_t *);
Index: uspace/lib/display/include/ipc/display.h
===================================================================
--- uspace/lib/display/include/ipc/display.h	(revision 338d09353f53dcb5fd2a315562bcd0b2588792d0)
+++ uspace/lib/display/include/ipc/display.h	(revision a2e104e0deacc5a9fdacf4d8e3824726c77c47a5)
@@ -42,4 +42,5 @@
 	DISPLAY_WINDOW_CREATE,
 	DISPLAY_WINDOW_DESTROY,
+	DISPLAY_WINDOW_MOVE_REQ,
 	DISPLAY_WINDOW_RESIZE,
 	DISPLAY_GET_EVENT
Index: uspace/lib/display/src/disp_srv.c
===================================================================
--- uspace/lib/display/src/disp_srv.c	(revision 338d09353f53dcb5fd2a315562bcd0b2588792d0)
+++ uspace/lib/display/src/disp_srv.c	(revision a2e104e0deacc5a9fdacf4d8e3824726c77c47a5)
@@ -100,5 +100,5 @@
 	wnd_id = ipc_get_arg1(icall);
 
-	if (srv->ops->window_create == NULL) {
+	if (srv->ops->window_destroy == NULL) {
 		async_answer_0(icall, ENOTSUP);
 		return;
@@ -106,4 +106,42 @@
 
 	rc = srv->ops->window_destroy(srv->arg, wnd_id);
+	async_answer_0(icall, rc);
+}
+
+static void display_window_move_req_srv(display_srv_t *srv, ipc_call_t *icall)
+{
+	sysarg_t wnd_id;
+	ipc_call_t call;
+	gfx_coord2_t pos;
+	size_t size;
+	errno_t rc;
+
+	wnd_id = ipc_get_arg1(icall);
+
+	if (!async_data_write_receive(&call, &size)) {
+		async_answer_0(&call, EREFUSED);
+		async_answer_0(icall, EREFUSED);
+		return;
+	}
+
+	if (size != sizeof(gfx_coord2_t)) {
+		async_answer_0(&call, EINVAL);
+		async_answer_0(icall, EINVAL);
+		return;
+	}
+
+	rc = async_data_write_finalize(&call, &pos, size);
+	if (rc != EOK) {
+		async_answer_0(&call, rc);
+		async_answer_0(icall, rc);
+		return;
+	}
+
+	if (srv->ops->window_move_req == NULL) {
+		async_answer_0(icall, ENOTSUP);
+		return;
+	}
+
+	rc = srv->ops->window_move_req(srv->arg, wnd_id, &pos);
 	async_answer_0(icall, rc);
 }
@@ -215,4 +253,7 @@
 		case DISPLAY_WINDOW_DESTROY:
 			display_window_destroy_srv(srv, &call);
+			break;
+		case DISPLAY_WINDOW_MOVE_REQ:
+			display_window_move_req_srv(srv, &call);
 			break;
 		case DISPLAY_WINDOW_RESIZE:
Index: uspace/lib/display/src/display.c
===================================================================
--- uspace/lib/display/src/display.c	(revision 338d09353f53dcb5fd2a315562bcd0b2588792d0)
+++ uspace/lib/display/src/display.c	(revision a2e104e0deacc5a9fdacf4d8e3824726c77c47a5)
@@ -244,4 +244,36 @@
 }
 
+/** Request a window move.
+ *
+ * Request the display service to initiate a user window move operation
+ * (i.e. let the user move the window). Used when the client detects
+ * mouse press on the title bar or such.
+ *
+ * @param window Window
+ * @return EOK on success or an error code
+ */
+errno_t display_window_move_req(display_window_t *window, gfx_coord2_t *pos)
+{
+	async_exch_t *exch;
+	aid_t req;
+	ipc_call_t answer;
+	errno_t rc;
+
+	exch = async_exchange_begin(window->display->sess);
+	req = async_send_1(exch, DISPLAY_WINDOW_MOVE_REQ, window->id, &answer);
+	rc = async_data_write_start(exch, (void *)pos, sizeof (gfx_coord2_t));
+	async_exchange_end(exch);
+	if (rc != EOK) {
+		async_forget(req);
+		return rc;
+	}
+
+	async_wait_for(req, &rc);
+	if (rc != EOK)
+		return rc;
+
+	return EOK;
+}
+
 /** Resize display window.
  *
@@ -283,6 +315,5 @@
  * @param nrect New bounding rectangle
  * @param offs
- * @return EOK on success or an error code. In both cases @a window must
- *         not be accessed anymore
+ * @return EOK on success or an error code
  */
 errno_t display_window_resize(display_window_t *window, gfx_coord2_t *offs,
Index: uspace/lib/display/test/display.c
===================================================================
--- uspace/lib/display/test/display.c	(revision 338d09353f53dcb5fd2a315562bcd0b2588792d0)
+++ uspace/lib/display/test/display.c	(revision a2e104e0deacc5a9fdacf4d8e3824726c77c47a5)
@@ -56,4 +56,5 @@
 static errno_t test_window_create(void *, display_wnd_params_t *, sysarg_t *);
 static errno_t test_window_destroy(void *, sysarg_t);
+static errno_t test_window_move_req(void *, sysarg_t, gfx_coord2_t *);
 static errno_t test_window_resize(void *, sysarg_t, gfx_coord2_t *,
     gfx_rect_t *);
@@ -65,4 +66,5 @@
 	.window_create = test_window_create,
 	.window_destroy = test_window_destroy,
+	.window_move_req = test_window_move_req,
 	.window_resize = test_window_resize,
 	.get_event = test_get_event
@@ -94,4 +96,8 @@
 	bool window_destroy_called;
 	sysarg_t destroy_wnd_id;
+
+	bool window_move_req_called;
+	sysarg_t move_req_wnd_id;
+	gfx_coord2_t move_req_pos;
 
 	bool window_resize_called;
@@ -294,4 +300,114 @@
 }
 
+/** display_window_move_req() with server returning error response works. */
+PCUT_TEST(window_move_req_failure)
+{
+	errno_t rc;
+	service_id_t sid;
+	display_t *disp = NULL;
+	display_wnd_params_t params;
+	display_window_t *wnd;
+	test_response_t resp;
+	gfx_coord2_t pos;
+
+	async_set_fallback_port_handler(test_display_conn, &resp);
+
+	// FIXME This causes this test to be non-reentrant!
+	rc = loc_server_register(test_display_server);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = loc_service_register(test_display_svc, &sid);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = display_open(test_display_svc, &disp);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(disp);
+
+	resp.rc = EOK;
+	display_wnd_params_init(&params);
+	params.rect.p0.x = 0;
+	params.rect.p0.y = 0;
+	params.rect.p0.x = 100;
+	params.rect.p0.y = 100;
+
+	rc = display_window_create(disp, &params, &test_display_wnd_cb,
+	    (void *) &resp, &wnd);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(wnd);
+
+	resp.rc = EIO;
+	resp.window_move_req_called = false;
+
+	pos.x = 42;
+	pos.y = 43;
+
+	rc = display_window_move_req(wnd, &pos);
+	PCUT_ASSERT_TRUE(resp.window_move_req_called);
+	PCUT_ASSERT_ERRNO_VAL(resp.rc, rc);
+	PCUT_ASSERT_INT_EQUALS(wnd->id, resp.move_req_wnd_id);
+	PCUT_ASSERT_INT_EQUALS(pos.x, resp.move_req_pos.x);
+	PCUT_ASSERT_INT_EQUALS(pos.y, resp.move_req_pos.y);
+
+	display_window_destroy(wnd);
+	display_close(disp);
+	rc = loc_service_unregister(sid);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** display_window_move_req() with server returning success response works. */
+PCUT_TEST(window_move_req_success)
+{
+	errno_t rc;
+	service_id_t sid;
+	display_t *disp = NULL;
+	display_wnd_params_t params;
+	display_window_t *wnd;
+	test_response_t resp;
+	gfx_coord2_t pos;
+
+	async_set_fallback_port_handler(test_display_conn, &resp);
+
+	// FIXME This causes this test to be non-reentrant!
+	rc = loc_server_register(test_display_server);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = loc_service_register(test_display_svc, &sid);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = display_open(test_display_svc, &disp);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(disp);
+
+	resp.rc = EOK;
+	display_wnd_params_init(&params);
+	params.rect.p0.x = 0;
+	params.rect.p0.y = 0;
+	params.rect.p0.x = 100;
+	params.rect.p0.y = 100;
+
+	rc = display_window_create(disp, &params, &test_display_wnd_cb,
+	    (void *) &resp, &wnd);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(wnd);
+
+	resp.rc = EOK;
+	resp.window_move_req_called = false;
+
+	pos.x = 42;
+	pos.y = 43;
+
+	rc = display_window_move_req(wnd, &pos);
+	PCUT_ASSERT_TRUE(resp.window_move_req_called);
+	PCUT_ASSERT_ERRNO_VAL(resp.rc, rc);
+	PCUT_ASSERT_INT_EQUALS(wnd->id, resp.move_req_wnd_id);
+	PCUT_ASSERT_INT_EQUALS(pos.x, resp.move_req_pos.x);
+	PCUT_ASSERT_INT_EQUALS(pos.y, resp.move_req_pos.y);
+
+	display_window_destroy(wnd);
+	display_close(disp);
+	rc = loc_service_unregister(sid);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
 /** display_window_resize() with server returning error response works. */
 PCUT_TEST(window_resize_failure)
@@ -1013,4 +1129,15 @@
 }
 
+static errno_t test_window_move_req(void *arg, sysarg_t wnd_id,
+    gfx_coord2_t *pos)
+{
+	test_response_t *resp = (test_response_t *) arg;
+
+	resp->window_move_req_called = true;
+	resp->move_req_wnd_id = wnd_id;
+	resp->move_req_pos = *pos;
+	return resp->rc;
+}
+
 static errno_t test_window_resize(void *arg, sysarg_t wnd_id,
     gfx_coord2_t *offs, gfx_rect_t *nrect)
